
#
# GENERATED WITH PDL::PP! Don't modify!
#
package PDL::Ops;

@EXPORT_OK  = qw( my_biop1 my_biop2 my_biop3 my_bifunc1 my_ufunc1 my_ufunc1f my_ufunc2 my_ufunc2f );
%EXPORT_TAGS = (Func=>[@EXPORT_OK]);

use PDL::Core;
use PDL::Exporter;
use DynaLoader;
@ISA    = qw( PDL::Exporter DynaLoader );

bootstrap PDL::Ops;


=head1 NAME

PDL::Ops - Fundamental mathematical operators

=head1 DESCRIPTION

This module provides the functions used by PDL to
overload the basic mathematical operators (C<+ - / *>
etc.) and functions (C<sin sqrt> etc.)

You probably don't need to know about this
and the interface may well
change so the documentation ends here.

=head1 SYNOPSIS

none

=cut







=head1 FUNCTIONS



=cut






=head2 my_biop1

=for sig

  Signature: (a(); b(); [o]c(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_biop1 {
		if($#_ == 3 || $#_ == -1 ) { &PDL::_my_biop1_int; }
		 elsif($#_ == 3) {
		 	@_ = @_;
		 	$_[3] = $_[3];
$_[2] = $_[2];
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_biop1_int;
		} elsif($#_ == 2) {
			@_ = @_;
			my @ret;
			$_[3] = $_[2];
unshift @ret,($_[2] = PDL->nullcreate($_[0]) );
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_biop1_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_biop1";
		}
		}

*my_biop1 = \&PDL::my_biop1;




=head2 my_biop2

=for sig

  Signature: (a(); b(); [o]c(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_biop2 {
		if($#_ == 3 || $#_ == -1 ) { &PDL::_my_biop2_int; }
		 elsif($#_ == 3) {
		 	@_ = @_;
		 	$_[3] = $_[3];
$_[2] = $_[2];
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_biop2_int;
		} elsif($#_ == 2) {
			@_ = @_;
			my @ret;
			$_[3] = $_[2];
unshift @ret,($_[2] = PDL->nullcreate($_[0]) );
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_biop2_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_biop2";
		}
		}

*my_biop2 = \&PDL::my_biop2;




=head2 my_biop3

=for sig

  Signature: (a(); b(); [o]c(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_biop3 {
		if($#_ == 3 || $#_ == -1 ) { &PDL::_my_biop3_int; }
		 elsif($#_ == 3) {
		 	@_ = @_;
		 	$_[3] = $_[3];
$_[2] = $_[2];
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_biop3_int;
		} elsif($#_ == 2) {
			@_ = @_;
			my @ret;
			$_[3] = $_[2];
unshift @ret,($_[2] = PDL->nullcreate($_[0]) );
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_biop3_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_biop3";
		}
		}

*my_biop3 = \&PDL::my_biop3;




=head2 my_bifunc1

=for sig

  Signature: (a(); b(); [o]c(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_bifunc1 {
		if($#_ == 3 || $#_ == -1 ) { &PDL::_my_bifunc1_int; }
		 elsif($#_ == 3) {
		 	@_ = @_;
		 	$_[3] = $_[3];
$_[2] = $_[2];
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_bifunc1_int;
		} elsif($#_ == 2) {
			@_ = @_;
			my @ret;
			$_[3] = $_[2];
unshift @ret,($_[2] = PDL->nullcreate($_[0]) );
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_bifunc1_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_bifunc1";
		}
		}

*my_bifunc1 = \&PDL::my_bifunc1;




=head2 my_ufunc1

=for sig

  Signature: (a(); [o]b(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_ufunc1 {
		if($#_ == 2 || $#_ == -1 ) { &PDL::_my_ufunc1_int; }
		 elsif($#_ == 2) {
		 	@_ = @_;
		 	$_[2] = $_[2];
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_ufunc1_int;
		} elsif($#_ == 1) {
			@_ = @_;
			my @ret;
			$_[2] = $_[1];
unshift @ret,($_[1] = PDL->nullcreate($_[0]) );
$_[0] = $_[0];

			&PDL::_my_ufunc1_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_ufunc1";
		}
		}

*my_ufunc1 = \&PDL::my_ufunc1;




=head2 my_ufunc1f

=for sig

  Signature: (a(); [o]b(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_ufunc1f {
		if($#_ == 2 || $#_ == -1 ) { &PDL::_my_ufunc1f_int; }
		 elsif($#_ == 2) {
		 	@_ = @_;
		 	$_[2] = $_[2];
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_ufunc1f_int;
		} elsif($#_ == 1) {
			@_ = @_;
			my @ret;
			$_[2] = $_[1];
unshift @ret,($_[1] = PDL->nullcreate($_[0]) );
$_[0] = $_[0];

			&PDL::_my_ufunc1f_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_ufunc1f";
		}
		}

*my_ufunc1f = \&PDL::my_ufunc1f;




=head2 my_ufunc2

=for sig

  Signature: (a(); [o]b(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_ufunc2 {
		if($#_ == 2 || $#_ == -1 ) { &PDL::_my_ufunc2_int; }
		 elsif($#_ == 2) {
		 	@_ = @_;
		 	$_[2] = $_[2];
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_ufunc2_int;
		} elsif($#_ == 1) {
			@_ = @_;
			my @ret;
			$_[2] = $_[1];
unshift @ret,($_[1] = PDL->nullcreate($_[0]) );
$_[0] = $_[0];

			&PDL::_my_ufunc2_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_ufunc2";
		}
		}

*my_ufunc2 = \&PDL::my_ufunc2;




=head2 my_ufunc2f

=for sig

  Signature: (a(); [o]b(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_ufunc2f {
		if($#_ == 2 || $#_ == -1 ) { &PDL::_my_ufunc2f_int; }
		 elsif($#_ == 2) {
		 	@_ = @_;
		 	$_[2] = $_[2];
$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_my_ufunc2f_int;
		} elsif($#_ == 1) {
			@_ = @_;
			my @ret;
			$_[2] = $_[1];
unshift @ret,($_[1] = PDL->nullcreate($_[0]) );
$_[0] = $_[0];

			&PDL::_my_ufunc2f_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_ufunc2f";
		}
		}

*my_ufunc2f = \&PDL::my_ufunc2f;


;


=head1 AUTHOR

Tuomas J. Lukka (lukka@fas.harvard.edu) and Karl Glazebrook
(kgb@aaoepp.aao.gov.au).

=cut





# Exit with OK status

1;

