
#
# GENERATED WITH PDL::PP! Don't modify!
#
package PDL::Tests;

@EXPORT_OK  = qw( foop dsumover fsumover nsumover setdim fooseg );
%EXPORT_TAGS = (Func=>[@EXPORT_OK]);

use PDL::Core;
use PDL::Exporter;
use DynaLoader;
@ISA    = qw( PDL::Exporter DynaLoader );

bootstrap PDL::Tests;


=head1 NAME

PDL::Tests - tests for some PP features

=head1 SYNOPSIS

  use PDL::Tests;

  <test code>

=head1 DESCRIPTION

This module provides some PP defined test functions that are
supposed to test some features/bugs of PDL::PP.

Strictly speaking this module shouldn't be installed with a
'make install' but I haven't yet worked out how to do it.

=cut







=head1 FUNCTIONS



=cut






=head2 foop

=for sig

  Signature: (byte [phys]a(n); byte [o,phys]b(n))

=for ref

internal

only for internal testing purposes


=cut




sub PDL::foop {
		if($#_ == 1 || $#_ == -1 ) { &PDL::_foop_int; }
		 elsif($#_ == 1) {
		 	@_ = @_;
		 	$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_foop_int;
		} elsif($#_ == 0) {
			@_ = @_;
			my @ret;
			unshift @ret,($_[1] = PDL->nullcreate($_[0]) );
$_[0] = $_[0];

			&PDL::_foop_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for foop";
		}
		}

*foop = \&PDL::foop;




=head2 dsumover

=for sig

  Signature: (a(n); double [o]b())

=for ref

internal

only for internal testing purposes


=cut




sub PDL::dsumover {
		if($#_ == 1 || $#_ == -1 ) { &PDL::_dsumover_int; }
		 elsif($#_ == 1) {
		 	@_ = @_;
		 	$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_dsumover_int;
		} elsif($#_ == 0) {
			@_ = @_;
			my @ret;
			unshift @ret,($_[1] = PDL->nullcreate($_[0]) );
$_[0] = $_[0];

			&PDL::_dsumover_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for dsumover";
		}
		}

*dsumover = \&PDL::dsumover;




=head2 fsumover

=for sig

  Signature: (a(n); float [o]b())

=for ref

internal

only for internal testing purposes


=cut




sub PDL::fsumover {
		if($#_ == 1 || $#_ == -1 ) { &PDL::_fsumover_int; }
		 elsif($#_ == 1) {
		 	@_ = @_;
		 	$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_fsumover_int;
		} elsif($#_ == 0) {
			@_ = @_;
			my @ret;
			unshift @ret,($_[1] = PDL->nullcreate($_[0]) );
$_[0] = $_[0];

			&PDL::_fsumover_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for fsumover";
		}
		}

*fsumover = \&PDL::fsumover;




=head2 nsumover

=for sig

  Signature: (a(n); int+ [o]b())

=for ref

internal

only for internal testing purposes


=cut




sub PDL::nsumover {
		if($#_ == 1 || $#_ == -1 ) { &PDL::_nsumover_int; }
		 elsif($#_ == 1) {
		 	@_ = @_;
		 	$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_nsumover_int;
		} elsif($#_ == 0) {
			@_ = @_;
			my @ret;
			unshift @ret,($_[1] = PDL->nullcreate($_[0]) );
$_[0] = $_[0];

			&PDL::_nsumover_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for nsumover";
		}
		}

*nsumover = \&PDL::nsumover;




=head2 setdim

=for sig

  Signature: ([o] a(n); int ns => n)

=for ref

internal

only for internal testing purposes


=cut




sub PDL::setdim {
		if($#_ == 1 || $#_ == -1 ) { &PDL::_setdim_int; }
		 elsif($#_ == 1) {
		 	@_ = @_;
		 	$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_setdim_int;
		} elsif($#_ == 0) {
			@_ = @_;
			my @ret;
			$_[1] = $_[0];
unshift @ret,($_[0] = PDL->nullcreate($_[0]) );

			&PDL::_setdim_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for setdim";
		}
		}

*setdim = \&PDL::setdim;




=head2 fooseg

=for sig

  Signature: (a(n);  [o]b(n))

=for ref

internal

only for internal testing purposes


=cut




sub PDL::fooseg {
		if($#_ == 1 || $#_ == -1 ) { &PDL::_fooseg_int; }
		 elsif($#_ == 1) {
		 	@_ = @_;
		 	$_[1] = $_[1];
$_[0] = $_[0];

			&PDL::_fooseg_int;
		} elsif($#_ == 0) {
			@_ = @_;
			my @ret;
			unshift @ret,($_[1] = PDL->nullcreate($_[0]) );
$_[0] = $_[0];

			&PDL::_fooseg_int;
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for fooseg";
		}
		}

*fooseg = \&PDL::fooseg;


;



# Exit with OK status

1;

